
#include "wx_dccan.h"
#include "wx_dcmem.h"
#include "wx_dcps.h"
#if USE_METAFILE
#include "wx_mf.h"
#endif


@INCLUDE wxs.xci

@HEADER

@CLASSBASE wxDC "wx:dc":"wx:object"

@CLASSID wxTYPE_DC

@SETMARK Q = V
@SETMARK q = q
@INCLUDE wxs_draw.xci
@SETMARK Q =
@SETMARK q =

@MACRO rZERO = return 0;
@MACRO rFALSE = return FALSE;

@ V "draw-icon" : void DrawIcon(wxIcon!,float,float);

@ V "blit" : bool Blit(float,float,float,float,wxCanvasDC!,float,float,int=wxCOPY); : : : rFALSE

@ V "set-map-mode" : void SetMapMode(int);
@ V "set-background-mode" : void SetBackgroundMode(int);
@ v "set-colour-map" : void SetColourMap(wxColourMap!);
@ V "set-user-scale" : void SetUserScale(float,float);

@ v "get-background" : wxBrush! GetBackground();
@ v "get-brush" : wxBrush! GetBrush();
@ v "get-font" : wxFont! GetFont();
@ v "get-logical-function" : int GetLogicalFunction();
@ v "get-map-mode" : int GetMapMode();
@ v "get-pen" : wxPen! GetPen();
@ v "get-text-background" : wxColour% GetTextBackground();
@ v "get-text-foreground" : wxColour% GetTextForeground();

@ v "get-size" : void GetSize(float*,float*);

@ V "device-to-logical-x" : float DeviceToLogicalX(int); : : : rZERO
@ V "device-to-logical-y" : float DeviceToLogicalY(int); : : : rZERO
@ V "logical-to-device-x" : float LogicalToDeviceX(int); : : : rZERO
@ V "logical-to-device-y" : float LogicalToDeviceY(int); : : : rZERO

@ v "max-x" : float MaxX();
@ v "max-y" : float MaxY();
@ v "min-x" : float MinX();
@ v "min-y" : float MinY();

@ v "ok?" : bool Ok();

@ V "start-doc" : bool StartDoc(string); : : : rFALSE
@ V "start-page" : void StartPage();
@ V "end-doc" : void EndDoc();
@ V "end-page" : void EndPage();

@CONSTANT "wx:const-oddeven-rule" : int wxODDEVEN_RULE
@CONSTANT "wx:const-winding-rule" : int wxWINDING_RULE

@CONSTANT "wx:const-and" : int wxAND
@CONSTANT "wx:const-and-invert" : int wxAND_INVERT
@CONSTANT "wx:const-and-reverse" : int wxAND_REVERSE
@CONSTANT "wx:const-clear" : int wxCLEAR
@CONSTANT "wx:const-copy" : int wxCOPY
@CONSTANT "wx:const-equiv" : int wxEQUIV
@CONSTANT "wx:const-invert" : int wxINVERT
@CONSTANT "wx:const-nand" : int wxNAND
@CONSTANT "wx:const-nor" : int wxNOR
@CONSTANT "wx:const-no-op" : int wxNO_OP
@CONSTANT "wx:const-or" : int wxOR
@CONSTANT "wx:const-or-invert" : int wxINVERT
@CONSTANT "wx:const-or-reverse" : int wxOR_REVERSE
@CONSTANT "wx:const-set" : int wxSET
@CONSTANT "wx:const-src-invert" : int wxSRC_INVERT
@CONSTANT "wx:const-xor" : int wxXOR

@END

@CLASSBASE wxCanvasDC "wx:canvas-dc":"wx:dc"

@CLASSID wxTYPE_DC_CANVAS

@CREATOR ();

@END

@CLASSBASE wxMemoryDC "wx:memory-dc":"wx:canvas-dc"

@CLASSID wxTYPE_DC_MEMORY

@CREATOR ();
@CREATOR (wxCanvasDC!);

@ "select-object" : void SelectObject(wxBitmap^);

@END

@CLASSBASE wxPostScriptDC "wx:post-script-dc":"wx:dc"

@CLASSID wxTYPE_DC_POSTSCRIPT

@CREATOR (string,bool=TRUE);

@END

#ifdef wx_msw

@CLASSBASE wxPrinterDC "wx:printer-dc":"wx:dc"

@CLASSID wxTYPE_DC_PRINTER

@CREATOR (string,string,string,bool=TRUE);

@END

#endif

#if USE_METAFILE

@CLASSBASE wxMetaFileDC "wx:meta-file-dc":"wx:dc"

@CLASSID wxTYPE_DC_METAFILE

@CREATOR (string=NULL);

@END

#endif
