
#include "wx_item.h"
#include "wx_messg.h"

@INCLUDE wxs.xci

@HEADER

@CLASSBASE wxItem "wx:item":"wx:window"

@CLASSID wxTYPE_ITEM

@CREATOR ();

@ "centre" : void Centre(int=wxHORIZONTAL);
@ "command" : void Command(wxCommandEvent%);

@INCLUDE wxs_icol.xci

@ "get-label" : string GetLabel();
@ "set-label" : void SetLabel(string);

@ "get-position" : void GetPosition(int*,int*);
@ "get-size" : void GetSize(int*,int*);
@ "set-size" : void SetSize(int,int,int,int,int=wxSIZE_AUTO);

@ "show" : void Show(bool);
@ "enable" : void Enable(bool);

@ "get-char-height" : float GetCharHeight();
@ "get-char-width" : float GetCharWidth();

@ "set-background-colour" : void SetBackgroundColour(wxColour!);
@ "set-label-colour" : void SetLabelColour(wxColour!);
@ "set-button-colour" : void SetButtonColour(wxColour!);

@CONSTANT "wx:const-size-auto" : int wxSIZE_AUTO
@CONSTANT "wx:const-size-auto-width" : int wxSIZE_AUTO_WIDTH
@CONSTANT "wx:const-size-auto-height" : int wxSIZE_AUTO_HEIGHT

@END

@CLASSBASE wxMessage "wx:message" : "wx:item"

@CREATOR (wxPanel!,string,int=-1,int=-1,long=0,string="message");

// @ "create" : void Create(wxPanel!,string,int=-1,int=-1,long=0,string="message");

@ "set-label" : void SetLabel(string);

@END
