
#include "wx_media.h"

@INCLUDE wxs.xci

@HEADER

@SET TYPE = float
@SET NOTEST = 1
@INCLUDE list.xci

@MACRO rNULL = return NULL;
@MACRO rFALSE = return FALSE;
@MACRO rZERO = return 0;

@CLASSBASE wxMediaBuffer "wx:media-buffer" : "wx:object"

@CLASSID wxTYPE_MEDIA_BUFFER

@IVAR "buffer-type" : int bufferType

@SETMARK X = V
@SETMARK Y = V
@SETMARK Z = v
@INCLUDE wxs_mbuf.xci

@ "global-to-local" : void GlobalToLocal(float*,float*);
@ "local-to-global" : void LocalToGlobal(float*,float*);

@ v "get-dc" : wxDC! GetDC();
@ v "get-view-size" : void GetViewSize(float?,float?);

@ "undo" :  void Undo();
@ "redo": void Redo()
@ "clear-undos" : void ClearUndos();

@ "set-max-undo-history" : void SetMaxUndoHistory(int);
@ "get-max-undo-history" : int GetMaxUndoHistory();

@ "append-edit-items" : int AppendEditItems(wxMenu!,int=0);
@ "append-font-items" : int AppendFontItems(wxMenu!,int=0);
@ "do-edit" : void DoEdit(int,bool=TRUE,long=0);
@ "do-font" : void DoFont(int,bool=TRUE);

@ "set-keymap" : void SetKeymap(wxKeymap^=NULL);
@ "get-keymap" : wxKeymap! GetKeymap();

@ "add-buffer-functions" : void AddBufferFunctions(wxKeymap!);

@ "get-style-list" : wxStyleList! GetStyleList();
@ "set-style-list" : void SetStyleList(wxStyleList!);

@ "lock" : void Lock(bool);
@ "modified?" : bool Modified();

@ "get-filename" : nstring GetFilename(bool?=NULL);

@ "insert-box" : void InsertBox(int=wxEDIT_BUFFER);
@ "insert-image" : void InsertImage(nstring=NULL,long=-1,bool=FALSE);

@ "print" : void Print(nstring=NULL,bool=TRUE);

@ "begin-write-header-footer-to-file" : bool BeginWriteHeaderFooterToFile(wxMediaStreamOut%,string,long*);
@ "end-write-header-footer-to-file" : bool EndWriteHeaderFooterToFile(wxMediaStreamOut%,long);

@CONSTANT "wx:const-edit-buffer" : int wxEDIT_BUFFER
@CONSTANT "wx:const-pasteboard-buffer" : int wxPASTEBOARD_BUFFER

@END

@GLOBAL wxMediaGlobal

@ "wx:get-media-print-margin" : void wxGetMediaPrintMargin(long?=NULL,long?=NULL);
@ "wx:set-media-print-margin" : void wxSetMediaPrintMargin(long=-1,long=-1);

@END
