
#include "wx_menu.h"

@HEADER

@INCLUDE wxs.xci

@CLASSBASE wxMenuItem "wx:menu-item" : "wx:object"
@END

@CLASSBASE wxMenu "wx:menu" : "wx:item"

@SET CALLBACK_CLASS = wxMenu
@INCLUDE cb_start.xci

@CREATOR (nstring=NULL,wxFunction=NULL/bCallback/ubCallback/cCallback); : : ubCallbackSetup///ubCallbackCreatorFinish

@ "append" : void Append(int,string,wxMenu!,string=NULL);
@ "append" : void Append(int,string,string=NULL,bool=FALSE);
@ "append-separator" : void AppendSeparator();
@ "checked?" : bool Checked(int);
@ "check" : void Check(int,bool);
@ "enable" : void Enable(int,bool);

@ "find-item" : int FindItem(string);
@ "find-item-for-id" : wxMenuItem^ FindItemForId(int);
@ "get-help-string" : string GetHelpString(int);
@ "get-label" : string GetLabel(int);
@ "get-title" : string GetTitle();

@ "set-help-string" : void SetHelpString(int, string);
@ "set-label" : void SetLabel(int, string);
@ "set-title" : void SetTitle(string);

@END

@INCLUDE cb_end.xci

@CLASSBASE wxMenuBar "wx:menu-bar" : "wx:item"

@SET TYPE = string
@SET NOTEST = 1
@INCLUDE list.xci

@SET TYPE = wxMenu
@SET POINTERS = 1
@INCLUDE list.xci

@CREATOR ();
@CREATOR (-int, wxMenu*[]/bList/ubList/cList, string[]/bList/ubList/cList); : : /glueListSet[wxMenu.0.1.0] | glueListSet[string.1.2.0]//

@ "append" : void Append(wxMenu!,string);
@ "check" : void Check(int,bool);
@ "checked?" : bool Checked(int);
@ "enable" : void Enable(int,bool);
@ "enable-top" : void EnableTop(int,bool);

@ "find-menu-item" : int FindMenuItem(string,string);
@ "find-item-for-id" : wxMenuItem^ FindItemForId(int);

@ "get-help-string" : string GetHelpString(int);
@ "get-label" : string GetLabel(int);
@ "get-label-top" : string GetLabelTop(int);
@ "get-title" : string GetTitle();

@ "set-help-string" : void SetHelpString(int, string);
@ "set-label" : void SetLabel(int, string);
@ "set-label-top" : void SetLabelTop(int, string);
@ "set-title" : void SetTitle(string);

@END
